Ext.onReady(function(){

	// Enable button tooltips
	Ext.QuickTips.init();

	Ext.ns('Ext.ux.form');
	Ext.ux.form.Spacer = Ext.extend(Ext.BoxComponent, {
	  height: 22,
	  autoEl: 'div' // thanks @jack =)
	});
	Ext.reg('spacer', Ext.ux.form.Spacer);
	Ext.ux.form.SpacerSmall = Ext.extend(Ext.BoxComponent, {
	  height: 4,
	  autoEl: 'div' // thanks @jack =)
	});
	Ext.reg('spacer_small', Ext.ux.form.SpacerSmall);

	var camera_target_label = new Ext.form.Label({
		text: target_string,
		disabled: !animates_camera
	});

	var choose_target_button = new Ext.Button({
		text: 'Choose Target...',
		disabled: !animates_camera,
		handler : function() {
			window.location = 'skp:on_choose_target@';
		}
	});

	var choose_angle_button = new Ext.Button({
		text: 'Choose Angle...',
		disabled: !animates_camera,
		handler : function() {
			window.location = 'skp:on_choose_angle@';
		}
	});

	var fixed_direction_button = new Ext.Button({
		text: 'Fixed Direction',
		disabled: !animates_camera,
		handler : function() {
			window.location = 'skp:on_fixed_direction@';
		}
	});

	var panel = new Ext.FormPanel({
		labelWidth: 50, 
		frame:true,
		title: title_text,
		width: 220,
		items: [
			new Ext.form.NumberField({
				fieldLabel: 'Frames',
				width: 80,
				value: initialFramesValue,
				disabled: frame_per_vertex,
				minValue: 2,
				listeners: {
					change: function (e) {
						window.location = 'skp:on_frames@' + e.value;
					}		
				}
			}),
			{
				xtype: 'checkbox',
				boxLabel: 'Frame At Each Vertex',
				hideLabel: true,
				checked: frame_per_vertex,
				handler : function() {
					window.location = 'skp:on_frame_per_vertex@';
				}
			},
			new Ext.Button({
				text: 'Reverse Direction',
				align: 'left',
				handler : function() {
					window.location = 'skp:on_reverse@';
				}
			}),
			{
				xtype: 'spacer'
			},
			{
				xtype: 'checkbox',
				boxLabel: 'Rotate Objects Along Path',
				hideLabel: true,
				checked: rotate_objects,
				handler : function() {
					window.location = 'skp:on_rotate_objects@';
				}
			},
			{
				xtype: 'spacer'
			},
			{
				xtype: 'checkbox',
				boxLabel: 'Animates the Camera',
				hideLabel: true,
				checked: animates_camera,
				handler : function() {
					window.location = 'skp:on_animates_camera@';
				}
			},
			camera_target_label,
			{
				xtype: 'spacer_small'
			},
			choose_target_button,
			{
				xtype: 'spacer_small'
			},
			choose_angle_button,
			{
				xtype: 'spacer_small'
			},
			fixed_direction_button
		],

		buttons: [{
			text: 'Save',
			handler : function() {
				window.location = 'skp:on_save@';
			}
		},{
			text: 'Cancel',
			handler : function() {
				window.location = 'skp:on_cancel@';
			}
		}]
	});

	// Putting the panel into a Viewport gets rid of the SU WebDialog scrollbar (on PC).
	new Ext.Viewport({
		title: 'Animations',
		layout: 'fit',
		items: [ 
			panel 
		]
	});
});