Ext.onReady(function(){

	// Enable button tooltips
	Ext.QuickTips.init();

	// Disable default context menu
	Ext.getBody().on("contextmenu", Ext.emptyFn, null, {preventDefault: true});

	// Spacers for panel layout
	Ext.ns('Ext.ux.form');
	Ext.ux.form.Spacer = Ext.extend(Ext.BoxComponent, {
	  height: 22,
	  autoEl: 'div' 
	});
	Ext.reg('spacer', Ext.ux.form.Spacer);
	Ext.ux.form.SpacerSmall = Ext.extend(Ext.BoxComponent, {
	  height: 4,
	  autoEl: 'div' 
	});
	Ext.reg('spacer_small', Ext.ux.form.SpacerSmall);

	// Grid of Layer names
	var reader = new Ext.data.ArrayReader({}, [
		{name: 'name'}
	]);

	var store = new Ext.data.Store({
		id:'theStore',
		reader: reader,
		data: layerArray
	});

	var gridPanel = new Ext.grid.EditorGridPanel({
		renderTo: Ext.getBody(),
		title: "Layer order for animation",
		store: store,
		multiSelect: true,
		reserveScrollOffset: false,
		autoWidth: true,
		height: 400,
		layout: 'fit',
		region: 'north',
		enableDragDrop : true,
		ddGroup : 'mygrid-dd',
		ddText : 'Move up or down',
		sm: new Ext.grid.RowSelectionModel({  
			singleSelect:false,
			listeners: {
				beforerowselect: function(sm,i,ke,row){
					gridPanel.ddText = row.data.name;
			}}
		}),

		listeners: {
			rowContextMenu: function (grid, rowIndex, extEventObject) {
				var xy = extEventObject.getXY();
				var name = grid.getStore().getAt(rowIndex).data["name"];
				this.contextMenu = new Ext.menu.Menu({
					items: [{
						text:'Remove from list',
						tooltip:'Remove layer from this list',
						handler : function(extEventObject, t) {
							var sm = gridPanel.getSelectionModel();
							var rows = sm.getSelections();
							if (sm.hasSelection()) {
								for (i = 0; i < rows.length; i++) {
									store.remove(store.getById(rows[i].id));
								}
							}  
						}
					}]
				});
				this.contextMenu.showAt(xy);
			}
		},

		columns: [{
			width: 197,
			dataIndex: 'name',
			sortable: false,
			editor: new Ext.form.TextField({
				allowBlank: false
			})
		}]
	});

	// Need renderTo above for this to load.
	var ddrow = new Ext.dd.DropTarget(gridPanel.getView().mainBody, {
		ddGroup : 'mygrid-dd',
		notifyDrop : function(dd, e, data){
			var sm = gridPanel.getSelectionModel();
			var rows = sm.getSelections();
			var cindex = dd.getDragData(e).rowIndex;
			if (sm.hasSelection()) {
				for (i = 0; i < rows.length; i++) {
					store.remove(store.getById(rows[i].id));
					store.insert(cindex,rows[i]);
				}
				sm.selectRecords(rows);
			}  
		}
	});

	var formPanel = new Ext.FormPanel({
		labelWidth: 100, 
		frame:true,
		width: 220,
		region: 'center',

		buttons: [{
			text: 'Save',
			handler : function() {
				// Report order of key frames
				var frames = "";
				store.each(function(record)  
				{  
					record.fields.each(function(field) 
					{ 
						frames += record.get(field.name) + '|';	   
					}); 
				}, this);
				window.location = 'skp:on_save@' + frames;
			}
		},{
			text: 'Cancel',
			handler : function() {
				window.location = 'skp:on_cancel@';
			}
		}]
	});

	// Putting the panel into a Viewport gets rid of the SU WebDialog scrollbar (on PC).
	new Ext.Viewport({
		title: 'Layers',
		layout: 'border',
		items: [ 
			gridPanel,
			formPanel 
		]
	});
});