Ext.onReady(function(){

	// Enable button tooltips
	Ext.QuickTips.init();

	Ext.ns('Ext.ux.form');
	Ext.ux.form.Spacer = Ext.extend(Ext.BoxComponent, {
	  height: 22,
	  autoEl: 'div' // thanks @jack =)
	});
	Ext.reg('spacer', Ext.ux.form.Spacer);
	Ext.ux.form.SpacerSmall = Ext.extend(Ext.BoxComponent, {
	  height: 4,
	  autoEl: 'div' // thanks @jack =)
	});
	Ext.reg('spacer_small', Ext.ux.form.SpacerSmall);

	var camera_target_label = new Ext.form.Label({
		text: target_string,
		disabled: !animates_camera
	});

	var choose_target_button = new Ext.Button({
		text: 'Choose Target...',
		disabled: !animates_camera,
		handler : function() {
			window.location = 'skp:on_choose_target@';
		}
	});

	var choose_angle_button = new Ext.Button({
		text: 'Choose Angle...',
		disabled: !animates_camera,
		handler : function() {
			window.location = 'skp:on_choose_angle@';
		}
	});

	var fixed_direction_button = new Ext.Button({
		text: 'Fixed Direction',
		disabled: !animates_camera,
		handler : function() {
			window.location = 'skp:on_fixed_direction@';
		}
	});

	var filenameFieldPlus = new Ext.form.CompositeField({
		fieldLabel: 'File',
		cls: 'align-right',
		items: [
			new Ext.form.TextField({
				width: 195,
				value: initialFilename,
				listeners: {
					change: function(e) {
						newName = e.getValue();
						if (newName != initialFilename) {
							window.location = 'skp:on_filename@' + newName;
							initialFilename = newName;
						}
					}
				}
			}),
			{
				xtype: 'button',
				text: '>',
				handler: function() { 
					window.location = 'skp:on_choose_file@'
				}
			}
		]
	});

	var panel = new Ext.FormPanel({
		labelWidth: 20, 
		frame:true,
		title: title_text,
		width: 260,
		items: [
			filenameFieldPlus,
			new Ext.Button({
				text: 'Choose File Format',
				align: 'right',
				handler : function() {
					window.location = 'skp:on_format@';
				}
			}),
			{
				xtype: 'spacer'
			},
			{
				xtype: 'checkbox',
				boxLabel: 'Rotate Objects Along Path',
				hideLabel: true,
				checked: rotate_objects,
				handler : function() {
					window.location = 'skp:on_rotate_objects@';
				}
			},
			{
				xtype: 'spacer'
			},
			{
				xtype: 'checkbox',
				boxLabel: 'Animates the Camera',
				hideLabel: true,
				checked: animates_camera,
				handler : function() {
					window.location = 'skp:on_animates_camera@';
				}
			},
			camera_target_label,
			{
				xtype: 'spacer_small'
			},
			choose_target_button,
			{
				xtype: 'spacer_small'
			},
			choose_angle_button,
			{
				xtype: 'spacer_small'
			},
			fixed_direction_button
		],

		buttons: [{
			text: 'Save',
			handler : function() {
				window.location = 'skp:on_save@';
			}
		},{
			text: 'Cancel',
			handler : function() {
				window.location = 'skp:on_cancel@';
			}
		}]
	});

	// Putting the panel into a Viewport gets rid of the SU WebDialog scrollbar (on PC).
	new Ext.Viewport({
		title: 'Animations',
		layout: 'fit',
		items: [ 
			panel 
		]
	});
});